"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _yylibUi = require("yylib-ui");

var _antd = require("antd");

var _ajax = require("yylib-utils/ajax");

var _ajax2 = _interopRequireDefault(_ajax);

require("../mgrNewDialog.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var QWebChannel = require("../qwebchannel").QWebChannel;

var _require = require("lodash"),
    isFunction = _require.isFunction;

var ADDR = require("../../BaseHost");
var Dragger = _antd.Upload.Dragger;
var radioStyle = {
  display: "block",
  height: "30px",
  lineHeight: "30px"
};
var imgPath,
    deletePath,
    timeOutNum = 0;
var AttachMgrModalNew = _yylibUi.YYClass.create({
  getInitialState: function getInitialState() {
    return {
      _urlUpload: ADDR,
      _urlDownLoad: ADDR,
      sourceId: this.props.sourceId || null,
      billType: this.props.billType || null,
      sourceType: this.props.sourceType ? this.props.sourceType : "102345678",
      visible: false,
      visibleHM: false,
      visiblePreview: false,
      //   value: 1,
      //   valueMethod: 1,
      videoUrl: "",
      imgPathArray: [], //base64路径，拍摄后显示本地图片
      deletePathArray: [], //删除的绝对路径标注
      deletedArray: [], //确认删除的数组
      deletedLength: 0,
      uploadArray: [],
      uploadFileList: [],
      deviceInfo: "",
      carouselList: [],
      imgPath: "",
      preViewTitle: [],
      preViewTitleIndex: [],
      setTimeoutFlag: false,
      getUploadList: []
    };
  },
  showModalHM: function showModalHM() {
    this.setState({
      visibleHM: true
    });
    if (timeOutNum === 0) {
      timeOutNum++;
      this.openSocket();
    } else {
      if (!window.dialog || !dialog) return;
      dialog.html_loaded("one");
    }
  },
  handleShowMadel: function handleShowMadel() {
    this.setState({
      visible: !this.state.visible
    });
  },
  hideModal: function hideModal() {
    this.setState({
      visible: false
    });
  },
  hideModalHM: function hideModalHM() {
    var _this2 = this;

    this.setState({
      visibleHM: false,
      setTimeoutFlag: true
    }, function () {
      if (!window.dialog || !dialog) return;
      dialog.get_actionType("closeSignal");
      _this2.imgVideo.src = "";
      imgPath = "";
      _this2.getUploadListFn();
    });
  },
  hideModalPreview: function hideModalPreview() {
    this.setState({
      visiblePreview: false
    });
  },
  onChangeMode: function onChangeMode(e) {
    this.setState({
      value: e.target.value
    });
  },
  onChangeMethod: function onChangeMethod(e) {
    this.setState({
      valueMethod: e.target.value
    });
  },
  // 防止高频点击
  debounce: function debounce(fn, delay) {
    var _this = this;
    return function () {
      var _arguments = arguments;

      _this.keyword = arguments[0];
      clearTimeout(_this.timer);
      _this.timer = setTimeout(function () {
        fn.apply(_this, _arguments);
      }, delay);
    };
  },
  // 获取文件后缀名
  fileSuffix: function fileSuffix(fileName) {
    var first = fileName.lastIndexOf(".");
    var namelength = fileName.length;
    var filesuffix = fileName.substring(first + 1, namelength);
    return filesuffix;
  },
  // base64转blob
  base64ToBlob: function base64ToBlob(base64Data) {
    var arr = base64Data.split(","),
        fileType = arr[0].match(/:(.*?);/)[1],
        bstr = atob(arr[1]),
        l = bstr.length,
        u8Arr = new Uint8Array(l);

    while (l--) {
      u8Arr[l] = bstr.charCodeAt(l);
    }
    return new Blob([u8Arr], {
      type: fileType
    });
  },
  // blob转file
  blobToFile: function blobToFile(newBlob, fileName) {
    newBlob.lastModifiedDate = new Date();
    newBlob.name = fileName;
    return newBlob;
  },
  openSocket: function openSocket() {
    var _this = this;
    var setTimeoutFlag = this.state.setTimeoutFlag;

    var baseUrl = "ws://127.0.0.1:12345";
    var socket = new WebSocket(baseUrl);
    socket.onerror = function (error) {
      if (error.type === "error") {
        _yylibUi.YYMessage.error("请检查设备驱动,连接后刷新页面尝试");
        if (!setTimeoutFlag) {
          setTimeout(function () {
            _this.openSocket();
          }, 2500);
        }
      }
    };
    socket.onopen = function () {
      new QWebChannel(socket, function (channel) {
        window.dialog = channel.objects.dialog;
        //网页关闭函数
        window.onbeforeunload = function () {
          //发送关闭信号
          dialog.get_actionType("closeSignal");
          //关闭socket
          socket.close();
        };
        window.onunload = function () {
          //发送关闭信号
          dialog.get_actionType("closeSignal");
          //关闭socket
          socket.close();
        };
        //服务器返回消息
        dialog.sendPrintInfo.connect(function (message) {
          //获取文件base64返回值
          if (message.indexOf("fileBase64:") >= 0) {
            var value = message.substr(11);
            alert(value);
            return;
          }
          if (message.indexOf("No equipment found!") >= 0) {
            _yylibUi.YYMessage.error("没有设备");
          }
          // 设备信息
          if (message.indexOf("priDevName:") >= 0) {
            message = message.substr(11);
            if (message.indexOf("USB") < 0) {
              _this.setState({
                deviceInfo: message
              });
            }
          }
          if (message.indexOf("savePhoto_success:") >= 0) {
            deletePath = message.substr(18);
            _this.addImgDiv();
          }
        });
        //接收图片流用来展示，多个，较小的base64数据
        dialog.send_priImgData.connect(function (message) {
          _this.imgVideo.src = "data:image/jpg;base64," + message;
          imgPath = "data:image/jpg;base64," + message;
        });
        //网页加载完成信号
        dialog.html_loaded("one");
      });
    };
  },
  // 添加拍照缩略图
  addImgDiv: function addImgDiv() {
    this.setState({
      imgPathArray: this.state.imgPathArray.concat(imgPath),
      uploadArray: this.state.uploadArray.concat(imgPath),
      deletePathArray: this.state.deletePathArray.concat(deletePath),
      deletedArray: this.state.deletedArray.concat(deletePath),
      deletedLength: this.state.deletedLength + 1
    });
  },
  // 拍照
  onClickBtn: function onClickBtn() {
    dialog.photoBtnClicked("primaryDev_");
    dialog.get_actionType("savePhotoPriDev");
  },
  // 选中图片
  handleCheckbox: function handleCheckbox(e, name, uploadName) {
    var _state = this.state,
        deletedArray = _state.deletedArray,
        uploadArray = _state.uploadArray,
        deletedLength = _state.deletedLength;

    var nameNew = deletedArray;
    var newUploadName = uploadArray;
    if (e.target.checked === true) {
      nameNew = deletedArray.concat(name);
      newUploadName = uploadArray.concat(uploadName);
      this.setState({
        deletedArray: nameNew,
        uploadArray: newUploadName,
        deletedLength: deletedLength + 1
      });
    } else {
      var index = deletedArray.indexOf(name);
      nameNew.splice(index, 1);
      newUploadName.splice(index, 1);
      this.setState({
        deletedArray: nameNew,
        uploadArray: newUploadName,
        deletedLength: deletedLength - 1
      });
    }
  },
  // 删除本地照片
  deleteHandleFile: function deleteHandleFile() {
    var _state2 = this.state,
        deletedArray = _state2.deletedArray,
        imgPathArray = _state2.imgPathArray,
        deletePathArray = _state2.deletePathArray;

    var newPathArr = imgPathArray,
        newDelPathArr = deletePathArray;
    if (!deletedArray.length) {
      _yylibUi.YYMessage.error("没有需要删除的照片");
      return;
    }
    for (var i = 0; i < deletedArray.length; i++) {
      var index = deletePathArray.indexOf(deletedArray[i]);
      newPathArr.splice(index, 1);
      newDelPathArr.splice(index, 1);
      dialog.get_functionTypes("deleteFile", deletedArray[i], "", "");
    }
    this.setState({
      imgPathArray: newPathArr,
      deletePathArray: newDelPathArr,
      deletedArray: [],
      uploadArray: [],
      deletedLength: 0
    });
  },
  //上传按钮
  handleUpload: function handleUpload() {
    var _this3 = this;

    var _state3 = this.state,
        uploadArray = _state3.uploadArray,
        deletedArray = _state3.deletedArray,
        sourceId = _state3.sourceId,
        billType = _state3.billType,
        sourceType = _state3.sourceType,
        _urlUpload = _state3._urlUpload;

    if (!uploadArray.length) {
      _yylibUi.YYMessage.error("请选择要上传的文件");
      return;
    }
    var fileNames = deletedArray.map(function (pathItem) {
      var slices = pathItem.split("\\");
      return slices[slices.length - 1];
    });
    var blobs = uploadArray.map(function (base64Item) {
      return _this3.base64ToBlob(base64Item);
    });
    var files = blobs.map(function (blobsItem, index) {
      return _this3.blobToFile(blobsItem, fileNames[index]);
    });

    var uploadRequest = function uploadRequest(len, index) {
      if (index >= len) {
        _yylibUi.YYMessage.success("上传成功");
        _this3.deleteHandleFile();
        _this3.setState({
          uploadArray: []
        });
        return;
      }
      var formData = new FormData();
      formData.append("sourceId", sourceId);
      formData.append("billType", billType);
      formData.append("sourceType", sourceType);
      formData.append("userId", _this3.props.userId);
      formData.append("userName", _this3.props.userName);
      formData.append("file", files[index], fileNames[index]);
      var xhr = new XMLHttpRequest();
      xhr.onreadystatechange = function () {
        if (xhr.readyState == 4) {
          if (xhr.status == 200) {
            uploadRequest(len, ++index);
          } else {}
        }
      };
      xhr.open("post", _urlUpload + "/icop-file/file/upload2", true);
      xhr.send(formData);
    };
    // uploadRequest(files.length, 0);
  },
  // 图片预览
  handlePreview: function handlePreview(file) {
    this.setState({
      previewImage: file.url || file.thumbUrl,
      previewVisible: true
    });
  },
  //展示预览窗
  handlePreviewShowModal: function handlePreviewShowModal(index) {
    this.setState({
      visiblePreview: true
    });
  },
  //获取上传的列表
  getUploadListFn: function getUploadListFn() {
    var _this4 = this;

    _ajax2.default.postJSON(this.state._urlUpload + "/icop-file/file/list?id=" + this.props.sourceId + "&billType=" + this.props.billType + "&type=" + this.props.sourceType, "", function (res) {
      var data = res.backData;
      _this4.setState({
        getUploadList: data
      });
    });
  },
  changeValue: function changeValue(value, fileLength) {
    if (!this.props.readOnly) {
      if (isFunction(this.props.onChange)) {
        this.props.onChange(value, fileLength);
      }
    }
  },
  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    if (!nextProps) return;
    this.getUploadListFn();
  },
  render: function render() {
    var _this5 = this;

    var _props = this.props,
        type = _props.type,
        icon = _props.icon,
        buttonText = _props.buttonText,
        visible = _props.visible,
        disabled = _props.disabled,
        ghost = _props.ghost;
    var _state4 = this.state,
        _urlUpload = _state4._urlUpload,
        value = _state4.value,
        valueMethod = _state4.valueMethod,
        imgPathArray = _state4.imgPathArray,
        deletePathArray = _state4.deletePathArray,
        deletedLength = _state4.deletedLength,
        preViewTitle = _state4.preViewTitle,
        preViewTitleIndex = _state4.preViewTitleIndex,
        getUploadList = _state4.getUploadList,
        deviceInfo = _state4.deviceInfo;


    var _this = this;
    var props = {
      name: "file",
      listType: "picture",
      showUploadList: false,
      action: _urlUpload + "/icop-file/file/upload2",
      data: {
        sourceId: this.props.sourceId,
        billType: this.props.billType, //业务单据类型
        sourceType: this.props.sourceType, //业务单据文件细分类别标识
        userId: this.props.userId,
        userName: this.props.userName
      },
      onChange: function onChange(info) {
        var status = info.file.status;

        if (status === "done") {
          var infoList = info.fileList;
          for (var i = 0; i < infoList.length; i++) {
            if (infoList[i].type !== "image/png" && infoList[i].type !== "image/x-icon" && infoList[i].type !== "image/jpeg" && infoList[i].type !== "image/gif") {
              infoList[i].thumbUrl = [require("./file.png")];
            }
          }
          _yylibUi.YYMessage.success(info.file.name + "\u4E0A\u4F20\u6210\u529F");
          _this.setState({
            uploadFileList: infoList,
            carouselList: infoList
          }, function () {
            _this.getUploadListFn();
          });
        } else if (status === "error") {
          _yylibUi.YYMessage.error(info.file.name + "\u4E0A\u4F20\u5931\u8D25");
        }
      }
    };
    return _react2.default.createElement(
      "div",
      {
        style: {
          display: "inline-block",
          position: "relative",
          top: "3px",
          marginRight: "6px"
        }
      },
      _react2.default.createElement(
        _yylibUi.YYButton,
        {
          icon: icon,
          type: type,
          ghost: ghost,
          disabled: disabled,
          onClick: this.handleShowMadel
        },
        "\u9644\u4EF6\u7BA1\u7406New"
      ),
      _react2.default.createElement(
        _yylibUi.YYModal,
        {
          className: "upload-con",
          title: [_react2.default.createElement(
            "div",
            null,
            _react2.default.createElement(
              _yylibUi.YYButton,
              { className: "title-btn", type: "primary", danger: true },
              "\u4E0A\u4F20\u6587\u4EF6"
            ),
            _react2.default.createElement(
              _yylibUi.YYButton,
              { className: "title-btn", onClick: this.showModalHM },
              "\u9AD8\u62CD\u4EEA"
            )
          )],
          visible: this.state.visible,
          footer: null,
          onCancel: this.hideModal
        },
        _react2.default.createElement(
          Dragger,
          _extends({}, props, {
            className: "upload-list-inline",
            multiple: true,
            onPreview: this.handlePreview
          }),
          _react2.default.createElement(
            "p",
            { className: "ant-upload-drag-icon" },
            _react2.default.createElement(_antd.Icon, { type: "cloud-upload" })
          ),
          _react2.default.createElement(
            "p",
            { className: "ant-upload-text" },
            "\u70B9\u51FB\u6216\u5C06\u6587\u4EF6\u62D6\u62FD\u5230\u6B64\u533A\u57DF\u4E0A\u4F20"
          ),
          _react2.default.createElement(
            "p",
            { className: "ant-upload-hint" },
            "\u6700\u5927\u652F\u630110MB"
          )
        ),
        _react2.default.createElement(
          "div",
          { className: "upload-list-item" },
          getUploadList ? getUploadList.map(function (item, index) {
            var mapSrc = void 0;
            _this5.fileSuffix(item.fileName) === "png" || _this5.fileSuffix(item.fileName) === "jpeg" || _this5.fileSuffix(item.fileName) === "jpg" || _this5.fileSuffix(item.fileName) === "ico" || _this5.fileSuffix(item.fileName) === "gif" || _this5.fileSuffix(item.fileName) === "bip" || _this5.fileSuffix(item.fileName) === "tiff" || _this5.fileSuffix(item.fileName) === "tga" || _this5.fileSuffix(item.fileName) === "eps" ? mapSrc = _urlUpload + "/" + item.filePath : mapSrc = [require("./file.png")];
            return _react2.default.createElement(
              "div",
              { key: item.gid, className: "load-list" },
              _react2.default.createElement("img", {
                className: "img-preview",
                title: "\u70B9\u51FB\u9884\u89C8",
                alt: item.fileName,
                src: mapSrc,
                onClick: function onClick() {
                  return _this5.handlePreviewShowModal(index);
                }
              }),
              _react2.default.createElement(
                "a",
                {
                  title: "\u70B9\u51FB\u4E0B\u8F7D",
                  href: _urlUpload + "/" + item.filePath + "?filename=" + item.fileName,
                  download: item.fileName
                },
                item.fileName
              )
            );
          }) : _react2.default.createElement(
            "div",
            null,
            "\u6CA1\u6709\u6587\u4EF6"
          )
        )
      ),
      _react2.default.createElement(
        _yylibUi.YYModal,
        {
          width: "100%",
          className: "high-meter-con",
          style: {
            height: "100%",
            position: "absolute",
            margin: 0,
            top: 0,
            transformOrigin: 0,
            paddingBottom: 0
          },
          title: [_react2.default.createElement(
            "div",
            null,
            _react2.default.createElement(
              "span",
              null,
              "\u9AD8\u62CD\u6444\u5F71\u4EEA\uFF1A"
            ),
            _react2.default.createElement(
              "span",
              { className: "switch-btn" },
              deviceInfo
            )
          )],
          visible: this.state.visibleHM,
          footer: null,
          onCancel: this.hideModalHM
        },
        _react2.default.createElement(
          "div",
          { className: "high-meter-body" },
          _react2.default.createElement(
            "div",
            { className: "high-meter-body-L" },
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-L-title" },
              _react2.default.createElement(
                "span",
                null,
                "\u5DF2\u62CD\u6444"
              ),
              _react2.default.createElement(
                "button",
                { type: "button", onClick: this.deleteHandleFile },
                "\u5220\u9664\u5DF2\u9009(",
                deletedLength,
                ")"
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-L-album" },
              _react2.default.createElement(
                "div",
                { className: "high-meter-body-L-album-L" },
                _react2.default.createElement(_antd.Icon, {
                  type: "folder-open",
                  className: "icon-caret",
                  style: {
                    position: "absolute",
                    left: "27px",
                    top: "6px",
                    fontSize: "36px"
                  }
                }),
                _react2.default.createElement(_antd.Icon, {
                  type: "caret-right",
                  style: {
                    position: "absolute",
                    left: "85px",
                    top: "29px",
                    fontSize: "12px",
                    transform: "scale(.7)"
                  }
                })
              ),
              _react2.default.createElement(
                "div",
                { className: "high-meter-body-L-album-R" },
                imgPathArray.length ? imgPathArray.map(function (item, index) {
                  return _react2.default.createElement(
                    "div",
                    { key: item, style: { position: "relative" } },
                    _react2.default.createElement("img", { width: "105", height: "85", src: item }),
                    _react2.default.createElement(_antd.Checkbox, {
                      defaultChecked: true,
                      onChange: function onChange(e) {
                        return _this5.handleCheckbox(e, deletePathArray[index], imgPathArray[index]);
                      }
                    })
                  );
                }) : _react2.default.createElement(
                  "div",
                  null,
                  "\u6CA1\u6709\u62CD\u7167"
                )
              )
            )
          ),
          _react2.default.createElement(
            "div",
            { className: "high-meter-body-C" },
            _react2.default.createElement("img", {
              className: "bigPriDev",
              ref: function ref(dom) {
                _this5.imgVideo = dom;
              }
            })
          ),
          _react2.default.createElement(
            "div",
            { className: "high-meter-body-R" },
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-mode" },
              _react2.default.createElement(
                "div",
                { className: "high-meter-body-R-mode-title" },
                "\u62CD\u7167\u6A21\u5F0F\uFF1A"
              ),
              _react2.default.createElement(
                _antd.Radio.Group,
                { onChange: this.onChangeMode, value: value },
                _react2.default.createElement(
                  _antd.Radio,
                  { style: radioStyle, value: 1 },
                  "\u5355\u5F20\u62CD\u6444"
                )
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-method" },
              _react2.default.createElement(
                "div",
                { className: "high-meter-body-R-method-title" },
                "\u547D\u540D\u65B9\u5F0F\uFF1A"
              ),
              _react2.default.createElement(
                _antd.Radio.Group,
                { onChange: this.onChangeMethod, value: valueMethod },
                _react2.default.createElement(
                  _antd.Radio,
                  { style: radioStyle, value: 1 },
                  "\u65E5\u671F\u547D\u540D"
                )
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-message" },
              _react2.default.createElement(
                "div",
                null,
                "\u5DF2\u62CD\u6570\u91CF\uFF1A",
                imgPathArray.length
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-action" },
              _react2.default.createElement(
                "button",
                {
                  type: "button",
                  className: "photoBtn",
                  onClick: this.debounce(this.onClickBtn, 1000)
                },
                "\u5F00\u59CB\u62CD\u6444"
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-upload" },
              _react2.default.createElement(
                _yylibUi.YYButton,
                { onClick: this.handleUpload, type: "button" },
                "\u7ACB\u5373\u4E0A\u4F20"
              )
            )
          )
        )
      ),
      _react2.default.createElement(
        _yylibUi.YYModal,
        {
          title: preViewTitle.length === 0 ? preViewTitle[0] : preViewTitle[preViewTitleIndex],
          className: "previewModal",
          visible: this.state.visiblePreview,
          footer: null,
          onCancel: this.hideModalPreview
        },
        _react2.default.createElement(
          _antd.Carousel,
          {
            ref: function ref(dom) {
              _this5.swipeBigPic = dom;
            }
          },
          getUploadList ? getUploadList.map(function (item) {
            var mapSrc = void 0;
            _this5.fileSuffix(item.fileName) === "png" || _this5.fileSuffix(item.fileName) === "jpeg" || _this5.fileSuffix(item.fileName) === "jpg" || _this5.fileSuffix(item.fileName) === "ico" || _this5.fileSuffix(item.fileName) === "gif" || _this5.fileSuffix(item.fileName) === "bip" || _this5.fileSuffix(item.fileName) === "tiff" || _this5.fileSuffix(item.fileName) === "tga" || _this5.fileSuffix(item.fileName) === "eps" ? mapSrc = _urlUpload + "/" + item.filePath : mapSrc = [require("./file.png")];
            return _react2.default.createElement(
              "div",
              { key: item.gid },
              _react2.default.createElement("img", {
                className: "img-preview",
                title: item.fileName,
                alt: item.fileName,
                src: mapSrc
              })
            );
          }) : ""
        )
      )
    );
  }
});
AttachMgrModalNew = _yylibUi.YYForm.create()(AttachMgrModalNew);
module.exports = AttachMgrModalNew;